<?php

namespace Drupal\entity_template_ui\Entity;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;

class TemplateBlueprintListBuilder extends EntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header = [];
    $header['label'] = $this->t('Label');
    $header['builder'] = $this->t('Builder');
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    /** @var \Drupal\entity_template\Entity\TemplateBuilder $entity */
    $row = [];
    $row['label']['data'] = [
      '#markup' => $entity->label(),
    ];

    /** @var \Drupal\entity_template\BlueprintTemplateBlueprintEntityAdaptor $blueprint */
    $blueprint = $entity->toBlueprint();
    $row['builder']['data'] = [
      '#markup' => $blueprint->getBuilder()->getPluginDefinition()['label'],
    ];

    return $row + parent::buildRow($entity);
  }

}
