<?php

namespace Drupal\entity_template_ui\Plugin\EntityTemplate\Template;

use Drupal\Core\Url;
use Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface;

abstract class BaseTemplateUI implements TemplateUIInterface {

  /**
   * @var \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  protected $template;

  /**
   * {@inheritdoc}
   */
  public function setTemplate(TemplateInterface $template): TemplateUIInterface {
    $this->template = $template;

    return $this;
  }

  /**
   * {@inheritdoc}
   *
   * Not all templates require conditions, so we return null by default.
   */
  public function addConditionUrl(): ?Url {
    return NULL;
  }

  /**
   * {@inheritdoc}
   *
   * Not all templates require conditions, so we return null by default.
   */
  public function configureConditionUrl(string $key): ?Url {
    return NULL;
  }

  /**
   * {@inheritdoc}
   *
   * Not all templates require conditions, so we return null by default.
   */
  public function removeConditionUrl(string $key): ?Url {
    return NULL;
  }

}
