<?php

namespace Drupal\entity_template\Entity;

use Drupal\Core\Entity\EntityInterface;
use Drupal\entity_template\BlueprintInterface;

interface BlueprintEntityInterface extends EntityInterface {

  /**
   * Update from BlueprintInterface object.
   *
   * @return static
   */
  public function updateFromBlueprint(BlueprintInterface $blueprint) : BlueprintEntityInterface;

  /**
   * Convert to an instance of BlueprintInterface.
   *
   * @return \Drupal\entity_template\BlueprintInterface
   */
  public function toBlueprint() : BlueprintInterface;

  /**
   * Get the blueprint builder.
   *
   * @return string
   */
  public function getBuilder() : string;

  /**
   * Get the templates configuration
   *
   * @return array
   */
  public function getTemplates() : array;

}
