<?php

namespace Drupal\entity_template;

use Drupal\Core\TempStore\PrivateTempStoreFactory;

/**
 * Tempstore repository interface for entity builder sessions.
 */
interface EntityBuilderTempStoreRepositoryInterface {

  /**
   * Get the tempstore id.
   *
   * @return string
   *   The tempstore id.
   */
  public function getTempstoreId();

  /**
   * Get the tempstore.
   *
   * @return \Drupal\Core\TempStore\PrivateTempStore
   *   The private tempstore.
   */
  public function getTempstore();

  /**
   * Get the builder result.
   *
   * @param string $session_key
   *   The session key.
   *
   * @return \Drupal\entity_template\BlueprintResult|null
   *   The builder result.
   */
  public function getBuilderResult(string $session_key);

  /**
   * Set the builder result.
   *
   * @param string $session_key
   *   The session key.
   * @param \Drupal\entity_template\BlueprintResult $result
   *   The result.
   */
  public function setBuilderResult(string $session_key, BlueprintResult $result);

}
