<?php

namespace Drupal\entity_template\Plugin\EntityTemplate\Component;

use Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface;

interface TemplateContextAwareComponentInterface {

  /**
   * Set the template.
   *
   * @param \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface $template
   *
   * @return static
   */
  public function setTemplate(TemplateInterface $template);

  /**
   * Get the template.
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  public function getTemplate() : TemplateInterface;

  /**
   * Get the context providing template.
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  public function getContextProvidingTemplate() : TemplateInterface;

}
