<?php

namespace Drupal\entity_template;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;

/**
 * Class TemplateBuilderManager
 *
 * @package Drupal\entity_template
 */
class TemplateBuilderManager extends DefaultPluginManager {

  /**
   * TemplateBuilderManager constructor.
   *
   * @param \Traversable $namespaces
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct(
      'Plugin/EntityTemplate/Builder',
      $namespaces,
      $module_handler, 'Drupal\entity_template\Plugin\EntityTemplate\Builder\BuilderInterface',
      'Drupal\entity_template\Annotation\EntityTemplateBuilder'
    );
    $this->alterInfo('entity_template_builder');
    $this->setCacheBackend($cache_backend, 'entity_template_builder');
  }

}
